import numpy as np
import matplotlib.pyplot as pl
import sys
myDir = sys.argv[1]
Rnm = np.loadtxt(myDir+'/eff_r.txt',ndmin=2)[:,1] + 1j*np.loadtxt(myDir+'/eff_r.txt',ndmin=2)[:,2]
Tnm = np.loadtxt(myDir+'/eff_t.txt',ndmin=2)[:,1] + 1j*np.loadtxt(myDir+'/eff_t.txt',ndmin=2)[:,2]
Q = [np.loadtxt(myDir+'/temp-Q_L_%g.txt'%k,ndmin=2)[:,1] for k in range(2,7)]
Q.append(np.loadtxt(myDir+'/temp-Q_scat.txt',ndmin=2)[:,1])
Q=np.array(Q)
TOT = Rnm.real.sum()+Tnm.real.sum()+Q.sum()

if myDir[6:]=='solarcell':
    Nmax=2
    tab_lambdas=np.loadtxt(myDir+'/temp_lambda_step.txt',ndmin=2)[:,8]
    nb_lambdas=len(tab_lambdas)
    Rnm = Rnm.reshape((nb_lambdas,2*Nmax+1,2*Nmax+1))
    Tnm = Tnm.reshape((nb_lambdas,2*Nmax+1,2*Nmax+1))
    Rtot = [Rnm[i].real.sum() for i in range(nb_lambdas)]
    Ttot = [Tnm[i].real.sum() for i in range(nb_lambdas)]
    Abs_rods = Q[-1]
    Abs_ITO  = Q[0]
    Abs_subs  = Q[2]+Q[3]+Q[4]+Ttot
    TOT = Rtot+Abs_rods+Abs_ITO+Abs_subs
    pl.figure()
    pl.plot(tab_lambdas,Abs_ITO,label='absorption ITO electrode')
    pl.plot(tab_lambdas,Abs_rods,label='absorption in Si rods')
    pl.plot(tab_lambdas,Abs_subs,label='absorption in Si subs')
    pl.plot(tab_lambdas,Rtot,label='reflection')
    pl.plot(tab_lambdas,TOT,label='total')
    pl.legend()
    pl.xlabel(r'$\lambda$ [nm]')
    pl.ylabel('fraction of incident energy')
    pl.savefig('solar_balance.pdf')
else:
    print('Rtot',Rnm.real.sum())
    print('Ttot',Tnm.real.sum())
    print('Atot',Q.sum())
    print('TOT ',TOT)
